import request from '@/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {ContractSettleRule, ContractSettleRuleParam} from './model';

/**
 * 分页查询合同设备
 */
export async function pageContract(params: ContractSettleRuleParam) {
  const res = await request.get<ApiResult<PageResult<ContractSettleRule>>>(
    '/tower/tower-contract-settle-rule/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询合同设备列表
 */
export async function listContractSettleRule(params?: ContractSettleRuleParam) {
  const res = await request.get<ApiResult<ContractSettleRule[]>>(
    '/tower/tower-contract-settle-rule',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询合同设备
 */
export async function getContractSettleRule(id: number) {
  const res = await request.get<ApiResult<ContractSettleRule>>(
    '/tower/tower-contract-settle-rule/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加合同设备
 */
export async function addContractSettleRule(data: ContractSettleRule) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-contract-settle-rule',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改合同设备
 */
export async function updateContractSettleRule(data: ContractSettleRule) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-contract-settle-rule',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量修改合同设备
 */
export async function updateBatchContractSettleRule(data: ContractSettleRule[]) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-contract-settle-rule/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量添加合同设备
 */
export async function addBatchContractSettleRule(data: ContractSettleRule[]) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-contract-settle-rule/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除合同设备
 */
export async function removeContractSettleRule(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-contract-settle-rule/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除合同设备
 */
export async function removeBatchContractSettleRule(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-contract-settle-rule/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
